How we manage the TLS protocol CRIME vulnerability

CRIME (“Compression Ratio Info-leak Made Easy”) is a security exploit against secret web cookies over connections using the HTTPS and SPDY protocols that also use data compression. When used to recover the content of secret authentication cookies, it allows an attacker to perform session hijacking on an authenticated web session, allowing the launching of further attacks. (CRIME)

Description

The TLS Protocol CRIME Vulnerability affects systems that use data compression over HTTPS. Your system might be vulnerable to the CRIME vulnerability if you use SSL Compression (for example, gzip) or SPDY (which optionally uses compression).

GitLab supports both gzip and SPDY and mitigates the CRIME vulnerability by deactivating gzip when HTTPS is enabled. The sources of the files are here:

Although SPDY is enabled in Omnibus installations, CRIME relies on compression (the ‘C’) and the default compression level in NGINX’s SPDY module is 0 (no compression).

Nessus

The Nessus scanner, reports a possible CRIME vulnerability in GitLab similar to the following format:

Description

This remote service has one of two configurations that are known to be required for the CRIME attack:
SSL/TLS compression is enabled.
TLS advertises the SPDY protocol earlier than version 4.

...

Output

The following configuration indicates that the remote service may be vulnerable to the CRIME attack:
SPDY support earlier than version 4 is advertised.

From the report above it is important to note that Nessus is only checking if TLS advertises the SPDY protocol earlier than version 4. It does not perform an attack nor does it check if compression is enabled. The Nessus scanner alone cannot tell that SPDY’s compression is disabled and not subject to the CRIME vulnerability.

References